// Code generated by goctl. DO NOT EDIT.
package types

import (
	"fusenapi/utils/basic"
)

type AddToCartReq struct {
	ProductId        int64  `json:"product_id"`        //产品id
	TemplateId       int64  `json:"template_id"`       //模板id
	SizeId           int64  `json:"size_id"`           //尺寸id
	FittingId        int64  `json:"fitting_id"`        //配件id
	PurchaseQuantity int64  `json:"purchase_quantity"` //购买数量
	Logo             string `json:"logo"`              //logo地址
	CombineImage     string `json:"combine_image"`     //合图地址
	RenderImage      string `json:"render_image"`      //渲染结果图
}

type DeleteCartReq struct {
	Id int64 `json:"id"` //购物车id
}

type ModifyCartPurchaseQuantityReq struct {
	Id       int64 `json:"id"`       //购物车id
	Quantity int64 `json:"quantity"` //数量
}

type GetCartsReq struct {
	Page int `form:"page"` //当前页
}

type GetCartsRsp struct {
	Meta     Meta       `json:"meta"` //分页信息
	CartList []CartItem `json:"cart_list"`
}

type CartItem struct {
	ProductId      int64          `json:"product_id"`      //产品id
	SizeInfo       SizeInfo       `json:"size_info"`       //尺寸信息
	FittingInfo    FittingInfo    `json:"fitting_info"`    //配件信息
	ItemPrice      string         `json:"item_price"`      //单价
	TotalPrice     string         `json:"totalPrice"`      //单价X数量=总价
	DiyInformation DiyInformation `json:"diy_information"` //diy信息
	StepNum        []int64        `json:"step_num"`        //阶梯数量
}

type SizeInfo struct {
	SizeId   int64     `json:"size_id"`  //尺寸id
	Capacity string    `json:"capacity"` //尺寸名称
	Title    SizeTitle `json:"title"`
}

type FittingInfo struct {
	FittingId   int64  `json:"fitting_id"`   //配件id
	FittingName string `json:"fitting_name"` //配件名称
}

type SizeTitle struct {
	Cm   string `json:"cm"`
	Inch string `json:"inch"`
}

type DiyInformation struct {
	Phone   string `json:"phone"`
	Address string `json:"address"`
	Website string `json:"website"`
	Qrcode  string `json:"qrcode"`
}

type Request struct {
}

type Response struct {
	Code    int         `json:"code"`
	Message string      `json:"msg"`
	Data    interface{} `json:"data"`
}

type Auth struct {
	AccessSecret string `json:"accessSecret"`
	AccessExpire int64  `json:"accessExpire"`
	RefreshAfter int64  `json:"refreshAfter"`
}

type File struct {
	Filename string              `fsfile:"filename"`
	Header   map[string][]string `fsfile:"header"`
	Size     int64               `fsfile:"size"`
	Data     []byte              `fsfile:"data"`
}

type Meta struct {
	TotalCount  int64 `json:"totalCount"`
	PageCount   int64 `json:"pageCount"`
	CurrentPage int   `json:"currentPage"`
	PerPage     int   `json:"perPage"`
}

// Set 设置Response的Code和Message值
func (resp *Response) Set(Code int, Message string) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
	}
}

// Set 设置整个Response
func (resp *Response) SetWithData(Code int, Message string, Data interface{}) *Response {
	return &Response{
		Code:    Code,
		Message: Message,
		Data:    Data,
	}
}

// SetStatus 设置默认StatusResponse(内部自定义) 默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatus(sr *basic.StatusResponse, data ...interface{}) *Response {
	newResp := &Response{
		Code: sr.Code,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}

// SetStatusWithMessage 设置默认StatusResponse(内部自定义) 非默认msg, 可以带data, data只使用一个参数
func (resp *Response) SetStatusWithMessage(sr *basic.StatusResponse, msg string, data ...interface{}) *Response {
	newResp := &Response{
		Code:    sr.Code,
		Message: msg,
	}
	if len(data) == 1 {
		newResp.Data = data[0]
	}
	return newResp
}
